require 'spec_helper'
require 'mongoid'

Mongoid.load!(File.join(File.dirname(__FILE__),"../mongoid.yml"), :test)

describe "md5_tools" do
    before(:each) do
        class TestMd5Object
            include Mongoid::Document
            include Mongoid::Attributes::Dynamic 
            field :email, type: String
            field :adress, type: String
            field :name, type: String
            field :groups, type: Array
            field :md5, type: String
        end
        @to = TestMd5Object.new({email: "test@email.com", adress: "New York", name: "Erhard", groups:["football","icehokey"]})
    end
    it "should create a md5 over some fields" do
        md5 = @to.md5_create(["email","adress"])
        puts md5
        expect(md5).to eq("2c36c501b5fd85afc39084bf94674214")
    end

    it "should create a long string of a field structure" do
        longString= @to.concat_string(["email","adress","name","groups"],"")
        expected_result="\"test@email.com\"\"New York\"\"Erhard\"[\"football\", \"icehokey\"]"
        expect(longString).to eq(expected_result)
    end

    it "should save a record" do
       TestMd5Object.delete_all()
       @to.find_or_create_with_md5(["email","adress","name","groups"])
       expect(TestMd5Object.count()).to eq(1) 
     end

    it "should not save a record and give back the object_id of the found md5" do
       TestMd5Object.delete_all()
       ##call it more times
       @to.find_or_create_with_md5(["email","adress","name","groups"])
       @to.find_or_create_with_md5(["email","adress","name","groups"])
       @to.find_or_create_with_md5(["email","adress","name","groups"])
       expect(TestMd5Object.count()).to eq(1) 
    end


    it "should be full the md5 field..." do
       TestMd5Object.delete_all()
       @to.find_or_create_with_md5(["email","adress","name","groups"])
       expect(@to.md5).to eq(@to.md5_create(["email","adress","name","groups"]))
    end


end


